#
# spec file for package openCOLLADA
#
# Copyright (c) 2024 SUSE LLC
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#


%global sover 0.3
%global sfx 0_3
#3335ac164e68b2512a40914b14c74db260e6ff7d
#3335ac1
%global upname OpenCOLLADA
%global libname libopenCOLLADA
Name:           openCOLLADA
Version:        1.6.68
Release:        2.2
#1_%%{shortcommit}
Summary:        Collada 3D import and export libraries
#https://github.com/KhronosGroup/OpenCOLLADA/archive/v1.6.43.tar.gz
License:        MIT
Group:          Development/Libraries/C and C++
URL:            https://collada.org/mediawiki/index.php/OpenCOLLADA
## https://github.com/KhronosGroup/OpenCOLLADA/archive/%%{commit}/
Source0:        https://github.com/KhronosGroup/%{upname}/archive/v%{version}.tar.gz#/%{upname}-%{version}.tar.gz
# PATCH-FIX-UPSTREAM use proper paths in cmake for install
Patch0:         opencollada-cmake.patch
# PATCH-FIX-UPSTREAM add missing includes
Patch1:         opencollada-includes.patch
# PATCH-FIX-UPSTREAM link to required libraries
# fixed in 1.6.51 Patch2:         opencollada-no-undefined.patch
# PATCH-FIX-UPSTREAM openCOLLADA-signed-char.patch gh#KhronosGroup/OpenCOLLADA#439 dimstar@opensuse.org -- Use signed char; 'char' by itself depends on arch implementation
#included         openCOLLADA-signed-char.patch
# PATCH-FIX-OPENSUSE openCOLLADA-no-daevalidator.patch davejplater@gmail.com - Don't build DAEvalidator app.
Patch4:         openCOLLADA-no-daevalidator.patch
Patch5:         openCOLLADA-pcre-redefined.patch
BuildRequires:  cmake
BuildRequires:  dos2unix
BuildRequires:  gcc-c++
BuildRequires:  pkgconfig(fftw3)
BuildRequires:  pkgconfig(libpcre)
BuildRequires:  pkgconfig(libpcrecpp)
BuildRequires:  pkgconfig(libxml-2.0)
BuildRequires:  pkgconfig(zlib)

%description
COLLADA is an XML schema that enables digital asset exchange within
the interactive 3D industry. OpenCOLLADA is a project providing
libraries for 3D file interchange between applications like Blender:
* COLLADABaseUtils - Utils used by many of the other projects
* COLLADAFramework - Datamodel used to load COLLADA files
* COLLADAStreamWriter - Sources (Library to write COLLADA files)
* COLLADASaxFrameworkLoader - Library that loads COLLADA files in a
  SAX-like manner into the framework data model
* COLLADAValidator - XML validator for COLLADA files, based on
  the COLLADASaxFrameworkLoader
* GeneratedSaxParser - Library used to load xml files in the way
  used by COLLADASaxFrameworkLoader

%package -n libftoa%{sfx}
Summary:        Collada 3D import and export libraries
Group:          System/Libraries

%description -n libftoa%{sfx}
COLLADA is a XML schema that enables digital asset exchange within
the interactive 3D industry. OpenCOLLADA is a project providing
libraries for 3D file interchange between applications like Blender.

%package -n libbuffer%{sfx}
Summary:        Collada 3D import and export libraries
Group:          System/Libraries

%description -n libbuffer%{sfx}
COLLADA is a XML schema that enables digital asset exchange within
the interactive 3D industry. OpenCOLLADA is a project providing
libraries for 3D file interchange between applications like Blender.

%package -n libGeneratedSaxParser%{sfx}
Summary:        Collada 3D import and export libraries
Group:          System/Libraries

%description -n libGeneratedSaxParser%{sfx}
COLLADA is a XML schema that enables digital asset exchange within
the interactive 3D industry. OpenCOLLADA is a project providing
libraries for 3D file interchange between applications like Blender.

GeneratedSaxParser is the library used to load xml files in the way
used by COLLADASaxFrameworkLoader.

%package -n libMathMLSolver%{sfx}
Summary:        Collada 3D import and export libraries
Group:          System/Libraries

%description -n libMathMLSolver%{sfx}
COLLADA is a XML schema that enables digital asset exchange within
the interactive 3D industry. OpenCOLLADA is a project providing
libraries for 3D file interchange between applications like Blender.

%package -n libOpenCOLLADABaseUtils%{sfx}
Summary:        Collada 3D import and export libraries
Group:          System/Libraries

%description -n libOpenCOLLADABaseUtils%{sfx}
COLLADA is a XML schema that enables digital asset exchange within
the interactive 3D industry. OpenCOLLADA is a project providing
libraries for 3D file interchange between applications like Blender.

COLLADABaseUtils is the package of utilitie used by many of the other
projects.

%package -n libOpenCOLLADAFramework%{sfx}
Summary:        Collada 3D import and export libraries
Group:          System/Libraries

%description -n libOpenCOLLADAFramework%{sfx}
COLLADA is a XML schema that enables digital asset exchange within
the interactive 3D industry. OpenCOLLADA is a project providing
libraries for 3D file interchange between applications like Blender.

COLLADAFramework is the datamodel used to load COLLADA files.

%package -n libOpenCOLLADASaxFrameworkLoader%{sfx}
Summary:        Collada 3D import and export libraries
Group:          System/Libraries

%description -n libOpenCOLLADASaxFrameworkLoader%{sfx}
COLLADA is a XML schema that enables digital asset exchange within
the interactive 3D industry. OpenCOLLADA is a project providing
libraries for 3D file interchange between applications like Blender.

COLLADASaxFrameworkLoader is a library that loads COLLADA files in a
SAX-like manner into the data framework model and is used by
COLLADASaxFrameworkLoader.

%package -n libOpenCOLLADAStreamWriter%{sfx}
Summary:        Collada 3D import and export libraries
Group:          System/Libraries

%description -n libOpenCOLLADAStreamWriter%{sfx}
COLLADA is a XML schema that enables digital asset exchange within
the interactive 3D industry. OpenCOLLADA is a project providing
libraries for 3D file interchange between applications like Blender.

COLLADAStreamWriter contains the library to write COLLADA files.

%package -n libUTF%{sfx}
Summary:        Collada 3D import and export libraries
Group:          System/Libraries

%description -n libUTF%{sfx}
COLLADA is a XML schema that enables digital asset exchange within
the interactive 3D industry. OpenCOLLADA is a project providing
libraries for 3D file interchange between applications like Blender.

%package     -n %{libname}-doc
Summary:        Developer documentation for %{name}
Group:          Documentation/HTML
Provides:       %{name}-doc > 1_3335ac1
Obsoletes:      %{name}-doc <= 1_3335ac1
BuildArch:      noarch

%description -n %{libname}-doc
This package provides documentation for %{name}.

%package        -n %{libname}-devel
Summary:        Include files for openCOLLADA development
Group:          Development/Libraries/C and C++
Requires:       libGeneratedSaxParser%{sfx} = %{version}
Requires:       libMathMLSolver%{sfx} = %{version}
Requires:       libOpenCOLLADABaseUtils%{sfx} = %{version}
Requires:       libOpenCOLLADAFramework%{sfx} = %{version}
Requires:       libOpenCOLLADASaxFrameworkLoader%{sfx} = %{version}
Requires:       libOpenCOLLADAStreamWriter%{sfx} = %{version}
Requires:       libUTF%{sfx} = %{version}
Requires:       libbuffer%{sfx} = %{version}
Requires:       libftoa%{sfx} = %{version}
Provides:       %{name}-devel > 1_3335ac1
Obsoletes:      %{name}-devel <= 1_3335ac1
Recommends:     %{libname}-doc = %{version}

%description -n %{libname}-devel
This package provides the include files necessary to build and
develop with the %{name} export and import libraries.

%package        -n %{libname}-utils
Summary:        XML validator for COLLADA files
Group:          Development/Tools
Provides:       %{name}-utils > 1_3335ac1
Obsoletes:      %{name}-utils <= 1_3335ac1

%description -n %{libname}-utils
XML validator for COLLADA files, based on the COLLADASaxFrameworkLoader.

%prep
%setup -q -n %{upname}-%{version}
%patch -P 0 -p0 -b .cmake
%patch -P 1 -p0 -b .includes
%patch -P 4
%patch -P 5

# Remove unused bundled libraries
rm -rf Externals/{Cg,expat,lib3ds,LibXML,MayaDataModel,pcre,zlib,zziplib}

# Add some docs, need to fix eol encoding with dos2unix in some files.
find ./ -name .project -delete
cp -pf COLLADAStreamWriter/README README.COLLADAStreamWriter
cp -pf COLLADAStreamWriter/LICENSE ./

iconv -f ISO_8859-1 -t utf-8 COLLADAStreamWriter/AUTHORS > \
  COLLADAStreamWriter/AUTHORS.tmp
touch -r COLLADAStreamWriter/AUTHORS COLLADAStreamWriter/AUTHORS.tmp
mv COLLADAStreamWriter/AUTHORS.tmp COLLADAStreamWriter/AUTHORS

dos2unix -f -k README.COLLADAStreamWriter
dos2unix -f -k LICENSE
dos2unix -f -k README
find htdocs/ -name *.php -exec dos2unix -f {} \;
find htdocs/ -name *.css -exec dos2unix -f {} \;

%build
%cmake \
       -DUSE_STATIC=OFF \
       -DUSE_SHARED=ON \
       -Dsoversion=%{sover}

make %{?_smp_mflags}

%install
%cmake_install

# Manually install binary
mkdir -p %{buildroot}%{_bindir}/
install -p -m 0755 build/bin/* %{buildroot}%{_bindir}/

# Install MathMLSolver headers
mkdir -p %{buildroot}%{_includedir}/MathMLSolver
cp -a Externals/MathMLSolver/include/* %{buildroot}%{_includedir}/MathMLSolver/

%post -n libbuffer%{sfx} -p /sbin/ldconfig
%postun -n libbuffer%{sfx} -p /sbin/ldconfig

%post -n libftoa%{sfx} -p /sbin/ldconfig
%postun -n libftoa%{sfx} -p /sbin/ldconfig

%post -n libGeneratedSaxParser%{sfx} -p /sbin/ldconfig
%postun -n libGeneratedSaxParser%{sfx} -p /sbin/ldconfig

%post -n libMathMLSolver%{sfx} -p /sbin/ldconfig
%postun -n libMathMLSolver%{sfx} -p /sbin/ldconfig

%post -n libOpenCOLLADABaseUtils%{sfx} -p /sbin/ldconfig
%postun -n libOpenCOLLADABaseUtils%{sfx} -p /sbin/ldconfig

%post -n libOpenCOLLADAFramework%{sfx} -p /sbin/ldconfig
%postun -n libOpenCOLLADAFramework%{sfx} -p /sbin/ldconfig

%post -n libOpenCOLLADASaxFrameworkLoader%{sfx} -p /sbin/ldconfig
%postun -n libOpenCOLLADASaxFrameworkLoader%{sfx} -p /sbin/ldconfig

%post -n libOpenCOLLADAStreamWriter%{sfx} -p /sbin/ldconfig
%postun -n libOpenCOLLADAStreamWriter%{sfx} -p /sbin/ldconfig

%post -n libUTF%{sfx} -p /sbin/ldconfig
%postun -n libUTF%{sfx} -p /sbin/ldconfig

%files -n libbuffer%{sfx}
%defattr(-,root,root)
%{_libdir}/libbuffer.so.%{sover}

%files -n libftoa%{sfx}
%defattr(-,root,root)
%{_libdir}/libftoa.so.%{sover}

%files -n libGeneratedSaxParser%{sfx}
%defattr(-,root,root)
%{_libdir}/libGeneratedSaxParser.so.%{sover}

%files -n libMathMLSolver%{sfx}
%defattr(-,root,root)
%{_libdir}/libMathMLSolver.so.%{sover}

%files -n libOpenCOLLADABaseUtils%{sfx}
%defattr(-,root,root)
%{_libdir}/libOpenCOLLADABaseUtils.so.%{sover}

%files -n libOpenCOLLADAFramework%{sfx}
%defattr(-,root,root)
%{_libdir}/libOpenCOLLADAFramework.so.%{sover}

%files -n libOpenCOLLADASaxFrameworkLoader%{sfx}
%defattr(-,root,root)
%{_libdir}/libOpenCOLLADASaxFrameworkLoader.so.%{sover}

%files -n libOpenCOLLADAStreamWriter%{sfx}
%defattr(-,root,root)
%{_libdir}/libOpenCOLLADAStreamWriter.so.%{sover}

%files -n libUTF%{sfx}
%defattr(-,root,root)
%{_libdir}/libUTF.so.%{sover}

%files -n %{libname}-doc
%defattr(-,root,root)
%doc htdocs/

%files  -n %{libname}-devel
%defattr(-,root,root)
%doc README LICENSE README.COLLADAStreamWriter COLLADAStreamWriter/AUTHORS
%{_libdir}/*.so
%{_libdir}/cmake/*
%{_includedir}/*

%files -n %{libname}-utils
%defattr(-,root,root)
%{_bindir}/*

%changelog
* Thu Feb 22 2024 Michael Vetter <mvetter@suse.com>
- Use %%patch -P N instead of deprecated %%patchN.
* Thu Aug 20 2020 Dirk Mueller <dmueller@suse.com>
- update to 1.6.68:
  * no upstream changelog available
* Wed Oct 10 2018 davejplater@gmail.com
- Update to version 1.6.63
- Add openCOLLADA-pcre-redefined.patch to fix build against new pcre.
- Upstream changes:
  * Load images declared in profile_COMMON
  * Corrected whitespace
  * Subclass effect loaders from image loaders so that images
  declared within effects are loaded properly
* Mon Jan 29 2018 davejplater@gmail.com
- Update to version 1.6.62, removed incorporated
  openCOLLADA-signed-char.patch.
- Upstream changes:
  * Add signed char keyword
  * Expose COLLADASaxFWL::Loader string ID -> UniqueId map
  * Export "Force to sleep" attribute.
  * Consistent use of std::abs
* Sun Jan 28 2018 davejplater@gmail.com
- Remove conflicts with old libOpenCOLLADA0 to allow parallel
  installation of different so versions.
* Sat Jun 10 2017 davejplater@gmail.com
- Update to release 1.6.51 to sync with blender.
- Bumped minor soversion to 3 to for blender fixes.
- Removed opencollada-no-undefined.patch.
- Rebased openCOLLADA-no-daevalidator.patch.
- Upstream changes from git log:
  * Better platform detection of hash-related includes.
  * CMAKE_VS_DEVENV_COMMAND variable not supported in older
    versions of cmake.
  * Code coverage specific code disabled.
  * Correctly link UTF (fixes opencollada-no-undefined.patch issue).
  * libBuffer depends on UTF.
  * PhysX schema.
* Thu May 18 2017 davejplater@gmail.com
- Update to version 1.6.47 Improved error handling (reporting
  errors instead of terminating Blender).
- For upstream changes see:
  https://github.com/KhronosGroup/OpenCOLLADA/tree/v1.6.47
* Tue Apr 11 2017 jengelh@inai.de
- RPM group fix
* Fri Apr  7 2017 davejplater@gmail.com
- Update to version 1.6.43
- Rebased opencollada-no-undefined.patch
- Added openCOLLADA-no-daevalidator.patch to prevent the building
  of the app DAEvalidator which tries to use internal zlib.
- For upstream changes see:
  https://github.com/KhronosGroup/OpenCOLLADA/tree/v1.6.43
* Tue Aug 16 2016 jengelh@inai.de
- Update rpm groups and descriptions
* Sun Aug 14 2016 davejplater@gmail.com
- Update to release version 1.6.25
- Renamed openCOLLADA-devel to libopenCOLLADA-devel, openCOLLADA-doc
  to libopenCOLLADA-doc and openCOLLADA-util to libopenCOLLADA-util
  due to upstream having a correct versioning scheme and version
  numbers derived from git are no longer neccessary. Conflicted,
  provided and obsoleted the old packages.
- Split libraries into separate sub packages.
- Refreshed patches.
- For upstream changes see:
  https://github.com/KhronosGroup/OpenCOLLADA/tree/v1.6.25
* Wed May 25 2016 dimstar@opensuse.org
- Add openCOLLADA-signed-char.patch: Use signed char; 'char' by
  itself depends on arch implementation
  (gh#KhronosGroup/OpenCOLLADA#439).
* Tue Aug  4 2015 davejplater@gmail.com
- Update to version 1_3335ac1 to enable blender to build with
  openCOLLADA again.
- Reworked opencollada-includes.patch
* Sat Jan  3 2015 tchvatal@suse.com
- Update package to match what is done in Fedora + what is needed
  for libreoffice. Move from svn snapshot to git snapshot
- Added patches:
  * opencollada-cmake.patch
  * opencollada-includes.patch
  * opencollada-no-undefined.patch
- Obsoleted patches:
  * openCOLLADA-COLLADABU_ASSERT.patch
  * openCOLLADA-cmakelinuxbuild.patch
  * openCOLLADA-gcc47.patch
* Mon Mar 26 2012 dimstar@opensuse.org
- Update to svn 868:
  + Support make install target
  + Fixes build with gcc 4.7
- Rebase openCOLLADA-cmakelinuxbuild.patch
- Add openCOLLADA-gcc47.patch: Fix some more gcc 4.7 issues.
* Sun May  8 2011 davejplater@gmail.com
- Fix for build flags included in openCOLLADA-cmakelinuxbuild.patch
  by adding -O2 to all builds except openCOLLADASaxFrameworkLoader.
* Fri May  6 2011 davejplater@gmail.com
- Moved the headers in devel subpackage to a named directory under
  /usr/include/<library name>
* Fri May  6 2011 davejplater@gmail.com
- Bumped library revision to 1 due to build changes.
* Tue May  3 2011 davejplater@gmail.com
- Update to svn 839.
- Fixed build with openCOLLADA-COLLADABU_ASSERT.patch.
- Upstream changes :
  * add hash_multimap
  * clean up header
  * fix asserts
* Sat Apr 23 2011 davejplater@gmail.com
- Switched to cmake build system and improved library versioning
  using openCOLLADA-cmakelinuxbuild.patch from Fedora with changes.
- libUTF, libbuffer and libftoa are no longer packaged and are
  statically linked to the openCOLLADA libs that use them.
* Thu Mar 31 2011 davejplater@gmail.com
- Update to svn836
- Upstream changes :
  * fix validation preprocessor flag
  * inti member variables
  * fix uri copy ctor, add missing includes
  * replace asserts
  * fix import
  * fix crash in utf conversion with recent gcc
  * replace asserts by custom assert
* Fri Feb 11 2011 davejplater@gmail.com
- Update to svn827
- Upstream changes:
  * fix Issue 125: cgfx shader source file is not honoring the
  search path on export.
  * fix Issue 89: CONTINUITY semantic is not defined. Define all
  semantics in COLLADASWInputList.h
  * partially fix Issue 71: wrong opacity for effects without set
  transparency
  * fix Issue 65: COLLADASaxFWL::Loader::loadDocument() don't check
  if the file correctly loads
  * fix Issue 62: build fixes for linux (gcc 4.4.3)
  * ignore bin and lib folder in pcre
  * Issue 35: IWriter start, cancel, and finish methods not called
  * remove precompiled pcre pattern from source
  * fix Issue 122: Root::loadDocument("../a/b/c.dae") attempts to
  open "../a/a/b/c.dae"
  * Issue 145: std::terminate() while loading lightwave dae through
  OpenCOLLADAValidator
  * fix Issue 146: OpenCOLLADAValidator crash
  COLLADASaxFWL::LibraryEffectsLoader::handleTexture
  * fix Issue 151: CMakeLists.txt overwrites custom CMAKE_CXX_FLAGS
  * Issue 153: crash in <articulated_system> improvements in
  kinematics loader related to mathml
* Fri Jan  7 2011 davejplater@gmail.com
- Spec file change to fix SLE_11_SP1 build made by repabuild.
* Mon Dec 27 2010 davejplater@gmail.com
- Update to svn788
- Upstream changes
  * fix Issue 148: Glitch in ftoa and dtoa (rename variables)
* Mon Nov 22 2010 davejplater@gmail.com
- Update to svn785
- Prevent build of dae2ogre with openCOLLADA-nodae2ogre.patch
- Upstream changes :
  * apply path from Issue 4: CMake or Scons
  * fix performance issue with many materials
  * fix: do not write empty <extra> element in <profile_COMMON>
  * apply patch (only first change) provided in Issue 136: Fix for
  color sets not exporting in colladaMaya
  * fix Issue 137: SetParam does not properly export float<n> with
  0's in it
* Sat Nov  6 2010 davejplater@gmail.com
- Update to svn 779 Removed openCOLLADA-assign_value.patch which is
  already incorporated in this revision.
- Upstream changes :
  * fix Issue 126: cgfx shader source file is not honoring the search
  path on export.
  * apply patch provided in Issue 4: CMake or Scons (add cmake files)
  * fix Issue 132: Small fix from compiling blender - collada with
  - Wall -Werror
  * fix Issue 131: Gcc will be initialized after warning fixes
* Tue Oct 26 2010 pth@suse.de
- Actually assign the passed value in setter function.
- Manually strip libraries
* Sun Oct 24 2010 davejplater@gmail.com
- Added patch COLLADA-linuxbuild.patch to fix shared lib build includes.
- Added patch openCOLLADA-buildflags.patch for optflags.
- Added patch openCOLLADA-soname.patch to add sonames to libs.
* Mon Oct 18 2010 davejplater@gmail.com
- Created new package openCOLLADA needed by blender-2.5x
- OpenCOLLADA is a stream based reader and writer library for
  COLLADA files. support@opencollada.org
